
Require PolyList.

Inductive Sum : (list nat) -> nat -> Prop :=
  | Sum_nil  : (Sum (nil nat) O) 
  | Sum_cons : (l:(list nat))(a:nat)(n:nat)
	       (Sum l n) -> (Sum (cons a l) (plus a n)).

Lemma sum_list : (l:(list nat)) { n:nat | (Sum l n) }.
Induction l.
Exists O. Exact Sum_nil.
Intros a l0 Hl0. Elim Hl0. Intros n hn. 
  Exists (plus a n). Apply Sum_cons. Assumption.
Save.

Require Extraction.
Write Caml File "sum" [sum_list].

Lemma sum_list_2 : (l:(list nat)) { n:nat | (Sum l n) }.
Realizer 
  Fix sum { sum [l:(list nat)] : nat := 
     Cases l of 
	nil => O
     | (cons a l0) => (plus a (sum l0)) end }.
Program_all.
Exact Sum_nil.
Apply Sum_cons. Assumption.

Require Programs.

